摘要:所以給定一個(gè)點(diǎn)的數(shù)組,要依次選擇每個(gè)點(diǎn)當(dāng)做第一個(gè)點(diǎn),依次求出它跟其他點(diǎn)的距離,如果相等則給結(jié)果加一,最后返回總數(shù)。數(shù)據(jù)結(jié)構(gòu)去存儲(chǔ)距離和這個(gè)距離出現(xiàn)的次數(shù)。代碼滿足條件的點(diǎn)的排列組合結(jié)果數(shù)
題目:
Given n points in the plane that are all pairwise distinct, a
"boomerang" is a tuple of points (i, j, k) such that the distance
between i and j equals the distance between i and k (the order of the
tuple matters).Find the number of boomerangs. You may assume that n will be at most
500 and coordinates of points are all in the range [-10000, 10000]
(inclusive).Example: Input: [[0,0],[1,0],[2,0]]
Output: 2
Explanation: The two boomerangs are [[1,0],[0,0],[2,0]] and
[[1,0],[2,0],[0,0]]
解法:
這道題主要條件是計(jì)算三點(diǎn)中第一個(gè)點(diǎn)到第二個(gè)點(diǎn)的距離和第一個(gè)點(diǎn)到第三個(gè)點(diǎn)的距離是否相等,因?yàn)轫樞蛴嘘P(guān),所以要返回到底有多少排列滿足這個(gè)條件。所以給定一個(gè)點(diǎn)的數(shù)組,
要依次選擇每個(gè)點(diǎn)當(dāng)做第一個(gè)點(diǎn), 依次求出它跟其他點(diǎn)的距離,如果相等則給結(jié)果加一,最后返回總數(shù)。
數(shù)據(jù)結(jié)構(gòu):
HashMap去存儲(chǔ)距離和這個(gè)距離出現(xiàn)的次數(shù)。
代碼:
public int numberOfBoomerangs(int[][] points){ int result = 0; HashMap() map= new HashMap<>(); for(int i = 0; i < points.length; i++){ for(int j = 0; j < points.length; j++){ if(i == j) continue; int distance = getDistance(points[i],points[j]); map.put(distance, map.getOrDefault(distance,0)+1); } for(int val : map.values()){ result += val*(val-1); //滿足條件的點(diǎn)的排列組合結(jié)果數(shù) } map.clear(); } return result; } public int getDistance(int[] point1, int[] point2){ int x = point1[0] - point2[0]; int y = point1[1] - point2[1]; return x*x + y*y; }
文章版權(quán)歸作者所有,未經(jīng)允許請勿轉(zhuǎn)載,若此文章存在違規(guī)行為,您可以聯(lián)系管理員刪除。
轉(zhuǎn)載請注明本文地址:http://systransis.cn/yun/66529.html
摘要:題目鏈接遍歷每個(gè),然后找和它等距離的其他,按距離來保存,比如有一個(gè)點(diǎn),和它距離都是的點(diǎn)有,,,那么一共的組合就有種,包括。這么算是不考重復(fù)的情況下。還有可能坐標(biāo)完全相同,那么和會(huì)被當(dāng)成兩個(gè)點(diǎn)算兩次。 447. Number of Boomerangs 題目鏈接:https://leetcode.com/problems... 遍歷每個(gè)point,然后找和它等距離的其他point,按距離...
摘要:月下半旬攻略道題,目前已攻略題。目前簡單難度攻略已經(jīng)到題,所以后面會(huì)調(diào)整自己,在刷算法與數(shù)據(jù)結(jié)構(gòu)的同時(shí),攻略中等難度的題目。 Create by jsliang on 2019-07-30 16:15:37 Recently revised in 2019-07-30 17:04:20 7 月下半旬攻略 45 道題,目前已攻略 100 題。 一 目錄 不折騰的前端,和咸魚有什么區(qū)別...
摘要:在線網(wǎng)站地址我的微信公眾號完整題目列表從年月日起,每天更新一題,順序從易到難,目前已更新個(gè)題。這是項(xiàng)目地址歡迎一起交流學(xué)習(xí)。 這篇文章記錄我練習(xí)的 LeetCode 題目,語言 JavaScript。 在線網(wǎng)站:https://cattle.w3fun.com GitHub 地址:https://github.com/swpuLeo/ca...我的微信公眾號: showImg(htt...
摘要:依次移位復(fù)雜度思路依次移動(dòng)位數(shù)進(jìn)行計(jì)算。代碼利用性質(zhì)復(fù)雜度,思路代碼 LeetCode[191] Number of 1 Bits Write a function that takes an unsigned integer and returns the number of ’1 bits it has (also known as the Hamming weight). Fo...
閱讀 2351·2019-08-30 15:44
閱讀 1274·2019-08-30 13:01
閱讀 3316·2019-08-30 11:22
閱讀 3104·2019-08-29 15:23
閱讀 1623·2019-08-29 12:22
閱讀 3385·2019-08-26 13:58
閱讀 3451·2019-08-26 12:17
閱讀 3488·2019-08-26 12:16